# swagger-client
This is the API behind the APIs.io search engine.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: V1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SearchApi(swagger_client.ApiClient(configuration))
body = swagger_client.APIsJSON() # APIsJSON | 

try:
    # Submit API
    api_response = api_instance.add_api(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SearchApi->add_api: %s\n" % e)

# create an instance of the API class
api_instance = swagger_client.SearchApi(swagger_client.ApiClient(configuration))
search = 'search_example' # str | Keyword to search by. (optional)
type = 'type_example' # str | Type to search by. (optional)
maintainer = 'maintainer_example' # str | Maintainer to search by. (optional)
limit = 'limit_example' # str |  (optional)
page = 'page_example' # str |  (optional)

try:
    # Search APIs
    api_response = api_instance.search_apis(search=search, type=type, maintainer=maintainer, limit=limit, page=page)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SearchApi->search_apis: %s\n" % e)

# create an instance of the API class
api_instance = swagger_client.SearchApi(swagger_client.ApiClient(configuration))
search = 'search_example' # str | Keyword to search by. (optional)
limit = 'limit_example' # str |  (optional)
page = 'page_example' # str |  (optional)

try:
    # Search Maintainers
    api_response = api_instance.search_maintainers(search=search, limit=limit, page=page)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SearchApi->search_maintainers: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://ibmwu99rx3.execute-api.us-east-1.amazonaws.com/staging*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SearchApi* | [**add_api**](docs/SearchApi.md#add_api) | **POST** /search/apis | Submit API
*SearchApi* | [**search_apis**](docs/SearchApi.md#search_apis) | **GET** /search/apis | Search APIs
*SearchApi* | [**search_maintainers**](docs/SearchApi.md#search_maintainers) | **GET** /search/maintainers | Search Maintainers

## Documentation For Models

 - [API](docs/API.md)
 - [APIsJSON](docs/APIsJSON.md)
 - [AnyOfSearchDataItems](docs/AnyOfSearchDataItems.md)
 - [Contact](docs/Contact.md)
 - [DiagnosticSeverity](docs/DiagnosticSeverity.md)
 - [Format](docs/Format.md)
 - [Formats](docs/Formats.md)
 - [Given](docs/Given.md)
 - [HumanReadableSeverity](docs/HumanReadableSeverity.md)
 - [Include](docs/Include.md)
 - [Latest](docs/Latest.md)
 - [LatestProperties](docs/LatestProperties.md)
 - [LatestPropertiesRules](docs/LatestPropertiesRules.md)
 - [LatestRules](docs/LatestRules.md)
 - [Maintainer](docs/Maintainer.md)
 - [MetaInformation](docs/MetaInformation.md)
 - [ModelProperty](docs/ModelProperty.md)
 - [PathExpression](docs/PathExpression.md)
 - [PublishAPIs](docs/PublishAPIs.md)
 - [PublishMaintainers](docs/PublishMaintainers.md)
 - [PublishProperties](docs/PublishProperties.md)
 - [PublishTags](docs/PublishTags.md)
 - [Rule](docs/Rule.md)
 - [Search](docs/Search.md)
 - [SearchLinks](docs/SearchLinks.md)
 - [SearchMeta](docs/SearchMeta.md)
 - [Severity](docs/Severity.md)
 - [Tag](docs/Tag.md)
 - [Then](docs/Then.md)
 - [UpdateMaintainers](docs/UpdateMaintainers.md)
 - [UpdateProperties](docs/UpdateProperties.md)
 - [UpdateTags](docs/UpdateTags.md)

## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

info@apievangelist.com
